POJ-3126-Prime Path(BFS)

Prime Path

Time Limit: 1000MS Memory Limit: 65536K
Total Submissions: 27852 Accepted: 15204

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. 

Now, the minister of finance, who had been eavesdropping, intervened. 
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 

1033
1733
3733
3739
3779
8779
8179

The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0

 

大致题意:

给定两个四位素数a  b,要求把a变换到b

变换的过程要保证  每次变换出来的数都是一个 四位素数,而且当前这步的变换所得的素数  与  前一步得到的素数  只能有一个位不同,而且每步得到的素数都不能重复。 不得有前导零!

 

求从a到b最少需要的变换次数。无法变换则输出Impossible

广度优先搜索

#include <iostream>
#include <cstring>
#include <cstdio>
#include <queue>

using namespace std;

const int N = 10000;

bool visit[N];
bool Notprime[N];
int dist[N];

void GetNotPrimeVisit (  )
{
    int i, j;
    for( i=2; i<=N; i++ )
        for( j=i<<1; j<=N; j+=i )
            Notprime[j] = true;
    fill( Notprime, Notprime+1000, true );        //以防万一把前一千个数去掉
}

int getnumber[45];
int x;
void SwapNumber( int v )                          
{
    x = 0;
    int i, a, b, c, d, n;
    a = v / 1000;
    b = v / 100 % 10;
    c = v % 100 / 10;
    d = v % 10;
    n = v - a * 1000;
    for( i=1; i<10; i++ )
        getnumber[x++] = n + i * 1000;
    n = v - b * 100;
    for( i=0; i<10; i++ )
        getnumber[x++] = n + i * 100;
    n = v - c * 10;
    for( i=0; i<10; i++ )
        getnumber[x++] = n + i * 10;
    n = v - d;
    for( i=0; i<10; i++ )
        getnumber[x++] = n + i;
}

queue <int> Q;
void BFS ( int a, int b )
{
    int i, j, v;
    int n = a;
    Q.push( n );
    visit[n] = true;
    while( !Q.empty() )
    {
        v = Q.front();
        if( v == b ) break;

        Q.pop();                  
        SwapNumber( v );                          //得到40个入口
        for( j=0; j<x; j++ )
        {
            i = getnumber[j];
            if( !Notprime[i] && !visit[i] )       //使用素数表和visit剪枝
            {
                Q.push( i );
                dist[i] = dist[v] + 1;
                visit[i] = true;
            }
        }
    }
    if( !Q.empty() ) cout << dist[v] << endl;
    else cout << "Impossible" << endl;
}


int main()
{
    GetNotPrimeVisit();                           //得到素数表
    int t;
    cin >> t;
    while( t-- )
    {
        fill( visit, visit+N, false );            //初始化
        fill( dist, dist+N, 0 );                  //初始化
        while( !Q.empty() ) Q.pop();              //初始化,清空队列
        int a, b;
        cin >> a >> b;
        BFS( a, b );                              //广搜
    }
    return 0;
}

转载于:https://www.cnblogs.com/gaojinmanlookworld/p/10586861.html

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值